var restposten = require('..');
var authorSchema = require('./author.schema.json');
var bookSchema = require('./book.schema.json');

// requires that a validator and a db engine are set
module.exports = function createSchemas(restposten) {
  var Author = restposten.define('author', authorSchema);
  var Book = restposten.define('book', bookSchema);

  Author.create({
    "_id" : "0001",
    "name" : "John Doe"
  }, function() {
  });

  Author.create({
    "_id" : "0002",
    "name" : "Jack Doe",
    "title" : "Sir"
  }, function() {
  });

  Author.create({
    "_id" : "0003",
    "name" : "Frank Doe"
  }, function() {
  });

  Author.create({
    "_id" : "0004",
    "name" : "Judy Doe",
    "title" : "Dr.med."
  }, function() {
  });

  Book.create({
    "_id" : "0001",
    "title" : "Plants - an introduction",
    "author" : "0001"
  }, function() {
  });

  Book.create({
    "_id" : "0002",
    "title" : "Ancient history",
    "author" : "0002"
  }, function() {
  });

  Book.create({
    "_id" : "0003",
    "title" : "Roman mythology",
    "author" : "0002"
  }, function() {
  });

  Book.create({
    "_id" : "0004",
    "title" : "Latent diseases",
    "author" : "0004"
  }, function() {
  });

  return [ Author, Book ];
};
