var restposten = require('..');
var dbConnector = require('restposten-memory');
var JaySchema = require('jayschema');
var flatiron = require('flatiron');
var broadway = require('broadway');
var restful = require('restful');

var model = require('./model.js');

var app = new flatiron.app;

restposten.validator = new JaySchema;

dbConnector.connect({
  name : 'restposten_test'
}, function(err, db) {
  if (err)
    throw err;

  restposten.database = db;

  app.resources = {};
  model(restposten).forEach(function(resource) {
    app.resources[resource.name] = resource;
  });
  
  app.use(flatiron.plugins.http, {
    headers : {
      'x-powered-by' : 'restposten',
    }
  });

  // create model
  app.use(restful);
  app.start(8080, function() {
    console.log(app.router.routes); // FIXME what's wrong here? restful tests
    console.log('> http server started on port 8080');
  });
});
